#ifndef CompareH
#define CompareH

// compare.h        revised  6/18/98
#include <fstream.h>
#include "profile.h"
#include "list.h"

/* 
class Compare is an abstract class that does nothing.
each type of Compare has different types of match scheme.  

Member function "Match()" checks if a profile has field that match exactly
to the search string.

if there is a "*" at the end of the input string, "WildCardMatch()", will 
check if characters up to "*" are same.

With a option parameter implemented, "CloseMatch()" looks for strings with
couple of mismatched characters.
*/


class Compare
  {
    public:
      virtual ~Compare() {};		   
      virtual bool Match(Profile P)=0;
      virtual bool CloseMatch(Profile P)=0;
      virtual bool WildCardMatch(Profile P)=0;
      virtual char* GetLookString()=0;
  };

class CompareFirstName:public Compare
  {
    public:
      CompareFirstName()                    {strcpy(LookString,0);}
      CompareFirstName(char* NameWanted)
        {  
          strcpy(LookString,NameWanted);  
//        cout<<"new compare name"<<endl; 
        }
     ~CompareFirstName()
        {
//          cout<<"destroy comparename"<<endl;
        } 

      bool Match(Profile P);
      bool CloseMatch(Profile P);
      bool WildCardMatch(Profile P);
      char* GetLookString()                  {return LookString;}

    private:
      char    LookString[100];
  };

class CompareLastName:public Compare
  {
    public:
      CompareLastName()                    {strcpy(LookString,0);}
      CompareLastName(char* NameWanted)   
        {
         strcpy(LookString,NameWanted);
//         cout<<"new compare name"<<endl;
        }
     ~CompareLastName()
        {
//          cout<<"destroy comparename"<<endl;
        } 

      bool Match(Profile P);
      bool CloseMatch(Profile P);
      bool WildCardMatch(Profile P);
      char* GetLookString()                  {return LookString;}
    private:
      char    LookString[100];
  };


class CompareStreet:public Compare
  {
    public:
      CompareStreet()                    {strcpy(LookString,0);}
      CompareStreet(char * StNameWntd)  
       {
          strcpy(LookString,StNameWntd); 
//          cout<<"new compare street"<<endl;
       }
     ~CompareStreet()
       { 
//         cout<<"destroy compare street"<<endl;
       }

      bool Match(Profile P);
      bool CloseMatch(Profile P);
      bool WildCardMatch(Profile P);
      char* GetLookString()                  {return LookString;}
			
    private:
      char    LookString[100];
};

class CompareCity:public Compare
  {
    public:
      CompareCity()                    {strcpy(LookString,0);}
      CompareCity(char * CityWntd)   
       {
         strcpy(LookString,CityWntd); 
//         cout<<"new compare city"<<endl;
       }
     ~CompareCity()
       {
//         cout<<"destroy compare city"<<endl;
       }

      bool Match(Profile P);
      bool CloseMatch(Profile P);
      bool WildCardMatch(Profile P);
      char* GetLookString()                  {return LookString;}			

    private:
      char    LookString[100];
};

class CompareState:public Compare
  {
    public:
      CompareState()                    {strcpy(LookString,0);}
      CompareState(char * StateWntd)   
       {
         strcpy(LookString,StateWntd); 
//         cout<<"new compare city"<<endl;
       }
     ~CompareState()
       {
//         cout<<"destroy compare city"<<endl;
       }

      bool Match(Profile P);
      bool CloseMatch(Profile P);
      bool WildCardMatch(Profile P);
      char* GetLookString()                  {return LookString;}			

    private:
      char    LookString[100];
};

// Below are the classes for changing the data type of 
// class profile.  Change() is the base class
// and ChangeXXX are the derived class of Change.

class Change
  {
    public: 
      virtual ~Change() {}; 
      virtual Profile* Edit(Profile &P)=0;
  };

class ChangeFirstName:public Change
  {
    public:
      ChangeFirstName()                    {strcpy(LookString,0);}
      ChangeFirstName(char* NameWanted)    {strcpy(LookString,NameWanted);}
      ~ChangeFirstName(){};
      Profile* Edit(Profile &P)            { return P.EditFirstName(LookString);}
    private:
      char    LookString[100];
  };

class ChangeLastName:public Change
  {
    public:
      ChangeLastName()                    {strcpy(LookString,0);}
      ChangeLastName(char* NameWanted)    {strcpy(LookString,NameWanted);}
      ~ChangeLastName(){};
      Profile* Edit(Profile &P)            { return P.EditLastName(LookString);}
    private:
      char    LookString[100];
  };

class ChangeStreet:public Change
  {
    public:
      ChangeStreet()                  {strcpy(LookString,0);}
      ChangeStreet(char* StreetWanted)    {strcpy(LookString,StreetWanted);}
      ~ChangeStreet(){};
      Profile* Edit(Profile &P)            { return P.EditStreet(LookString);}
    private:
      char    LookString[100];
  };

class ChangeCity:public Change
  {
    public:
      ChangeCity()                  {strcpy(LookString,0);}
      ChangeCity(char* CityWanted)    {strcpy(LookString,CityWanted);}
      ~ChangeCity(){};
      Profile* Edit(Profile &P)            { return P.EditCity(LookString);}
    private:
      char    LookString[100];
  };

class ChangeState:public Change
  {
    public:
      ChangeState()                     {strcpy(LookString,0);}
      ChangeState(char* StateWanted)    {strcpy(LookString,StateWanted);}
      ~ChangeState(){};
      Profile* Edit(Profile &P)            { return P.EditState(LookString);}
    private:
      char    LookString[100];
  };

#endif
