#ifndef ListH
#define ListH

#include <iostream.h>
#include <float.h>
#include "profile.h"

template<class T> class ListIterator;

template<class T>
class List {
public:
    List() : first(0), last(0), numelts(0){}
/*
    ~List() {
        while (first != 0) {
            Node* p;
cout<<"~list"<<first<<endl;
            p = first->link;
            delete first;
            first = p;
            delete p;
        }
    }
*/
    int NumElts() {return numelts;}

    void add(T x) {
        numelts++;
        if (first == 0) {first = last = new Node(x);}
        else {last = last->link = new Node(x);}
//cout<<"new"<<last<<endl;
    }

    void insert(T x, int n)     //inserts the node of x of 
      {                           //type T after nth element.
        int i=1;
        Node* cur=first;
        Node node(x);
        while (i<numelts)
        {
          if (i==n)
            {
             node.link=cur->link;
             cur->link=&node;
             numelts++;
             cur=cur->link;          //after insertion, the cur points
            }                        // to the inserted node.
          cur=cur->link;
          i++;
        }
      }

    void remove(T x);
    // ...

    friend class ListIterator<T>;

private:
    class Node {
    public:
        Node(T x) : link(0), datum(x) {}
        Node* link;
        T     datum;
    };

    Node* first;
    Node* last;
    int   numelts;
//    List(const List<T>&);  // Prohibit, since not implemented 
//    List<T>& operator=(const List<T>&);  // Prohibit, since not
//implemented 
};



template<class T>
class ListIterator {
public:
    ListIterator(const List<T>& list) : cur(list.first) {}

    bool    more()    const { return cur != 0;         }
    T       current() const { return cur->datum;       }
    void    advance()       { cur = cur->link;         }
    T       next()    const { return cur->link->datum; }

private:
    List<T>::Node* cur;
};


template<class T>
inline void List<T>::remove(T x) {
  Node* prev = 0;
  Node* cur = first;
  while (cur != 0) {
    if (cur->datum == x) {
      numelts--;
      if (prev == 0) {
        first = cur->link;
        delete cur;
        cur = first;
      } else {
        prev->link = cur->link;
        delete cur;
        cur = prev->link;
      }
    } else {
      prev = cur;
      cur = cur->link;
    }
  }
}
#endif
