#include <fstream.h>
#include "profile.h"

/*
profile.cc contains member function of the class Profile.
"Display" outputs the elements of the profile.
Later I will have a condition parameter that selects which fields to be
displayed.
*/

void Profile::Display()
  {
    cout<<prof_num<<endl;
    cout<<first_name<<endl;
    cout<<last_name<<endl;
    cout<<address.GetStreetAddress()<<endl;
    cout<<address.GetCity()<<endl;
    cout<<address.GetState()<<endl;
    cout<<endl;
  }

void Profile::Save(ostream& SaveFile)
  {

    SaveFile<<prof_num<<endl;
    SaveFile<<first_name<<endl;
    SaveFile<<last_name<<endl;
    SaveFile<<address.GetStreetAddress()<<endl;
    SaveFile<<address.GetCity()<<endl;
    SaveFile<<address.GetState()<<endl;
    SaveFile<<endl;

  }

/*
"StreetAddress" of class Address contains both house number and street name.
However, people usually do not use house number to search for an address.
So "MakeStreetName" allows to extract the street name from the "StreetAddress".

"MakeStreetName" looks for first blank character and consider as house number.
Then the rest of "StreetAddress" is copied to "StreetName" character by
character.

The character check uses variables, blank and check, to avoid error of
comparrison between pointer and integer.  
This error occurs if I check s[i]=="any character"
*/

void Address::MakeStreetName()
  {

	
    int HouseNumBuffer=0;
    int i;
    char blank=' ';
    char check=street_address[0];
    while(check!=blank)            //counts # of spaces devoted for house #
      {
        HouseNumBuffer++;
        check=street_address[HouseNumBuffer];
      }

//middle term means: (length of street_address)-(length of house number)

    for(i=0;i<strlen(street_address)-HouseNumBuffer;i++)   
      {                        
        street_name[i]=street_address[i+HouseNumBuffer+1];   //+1 is to avoid
                                                         //first blank character.
      }
//    char e='\n';
//    cout<<"I'm here"<<endl;
// street_name[strlen(street_address)-HouseNumBuffer]='\n';
}
